//***************************
//* akStreetFight - RM script
//* Created by AK, ZeroDexter
//* 2003-1-2 to 2003-1-18
//***************************

// Dominate the city and rule

// Global constants (copied from AI)
// =================================
//Tech Status:
const int cTechStatusUnobtainable=0;
const int cTechStatusObtainable=1;
const int cTechStatusAvailable=2;
const int cTechStatusResearching=3;
const int cTechStatusActive=4;
const int cTechStatusPersistent=5;

const int cTechArchitects=60;
const int cTechOlympicParentage=161;
const int cTechAthenianWall=242;


// Global variables
// ================
float startPosX=0.0;
float startPosZ=0.0;
float dest1PosX=0.0;
float dest1PosZ=0.0;
float centerPosX=0.0;
float centerPosZ=0.0;
float dest2PosX=0.0;
float dest2PosZ=0.0;
float endPosX=0.0;
float endPosZ=0.0;

float factorX=0.0;
float factorZ=0.0;

int tempArmy = -1;
int tempUnit = -1;
int tempUnitPlaced=-1;


int tempRevealer = -1;

string akGetHeroUnit(int aPlayer=0)
{
   if(rmGetPlayerCulture(aPlayer) == cCultureGreek) 
      return("Arkantos");
   if(rmGetPlayerCulture(aPlayer) == cCultureNorse) 
      return("Reginleif");
    if(rmGetPlayerCulture(aPlayer) == cCultureEgyptian) 
      return("Amanra");
}

void akCreateBasicTriggers(void)
{
      rmCreateTrigger("Start01");
      rmAddTriggerCondition("Always");

      for(i=1; <= cNumberNonGaiaPlayers)
      {
         rmAddTriggerEffect("Diplomacy");
         rmSetTriggerEffectParamInt("Player1",0);
         rmSetTriggerEffectParamInt("Player2",i);
         rmSetTriggerEffectParam("Status","neutral");
         rmAddTriggerEffect("Diplomacy");
         rmSetTriggerEffectParamInt("Player1",i);
         rmSetTriggerEffectParamInt("Player2",0);
         rmSetTriggerEffectParam("Status","neutral");

      }

      rmSetTriggerPriority(5);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);

      rmCreateTrigger("Intro01");
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",1);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","Your heroes fame will make the people join your side. Your fate is bound to your heroes life.");

      rmSetTriggerPriority(2);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
  
      rmCreateTrigger("Intro02");
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",10);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","Each district on your side will give support to you.");

      rmSetTriggerPriority(5);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);

      rmCreateTrigger("Intro03");
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",25);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","Let the show begin.");

      rmSetTriggerPriority(5);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);

}

void akCreateWinLoseTriggers(void)
{
   for(i=1; <= cNumberNonGaiaPlayers)
   {
      rmCreateTrigger("LoseP"+i);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",20);

      rmAddTriggerCondition("Player Unit Count");
      rmSetTriggerConditionParamInt("PlayerID",i);
      rmSetTriggerConditionParam("ProtoUnit",akGetHeroUnit(i));
      rmSetTriggerConditionParam("Op","==");
      rmSetTriggerConditionParamInt("Count", 0);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","This is the end for you, "+rmGetPlayerName(i)+". Your hero is gone and so are you.");

      rmAddTriggerEffect("Set Player Defeated");
      rmSetTriggerEffectParamInt("Player", i);

      rmSetTriggerPriority(9);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);

   }
}

void akCreateTechTriggers(void)
{
   // Balancing 
   // =========
   // Greatly increase Hero HP and Building HP 
   for(i=1; <cNumberPlayers)
   {
      rmCreateTrigger("TechPowerUp"+i);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);

      for(j=1; <10)
      {
         rmAddTriggerEffect("Set Tech Status");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParamInt("Status", cTechStatusActive); 
         rmSetTriggerEffectParamInt("TechID", cTechOlympicParentage);
      }

      for(j=1; <30)
      {
         rmAddTriggerEffect("Set Tech Status");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParamInt("Status", cTechStatusActive); 
         rmSetTriggerEffectParamInt("TechID", cTechArchitects);

         rmAddTriggerEffect("Set Tech Status");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParamInt("Status", cTechStatusActive); 
         rmSetTriggerEffectParamInt("TechID", cTechAthenianWall);

      }

   // Remove Bolt/Give Lightning 
      if (rmGetPlayerCiv(i) == cCivZeus)
      {
         rmCreateTrigger("RestrictBolt"+i);
         rmSetTriggerPriority(5);
         rmSetTriggerActive(true);
         rmSetTriggerRunImmediately(false);

         rmAddTriggerCondition("Timer");
         rmSetTriggerConditionParamInt("Param1",15);

         rmAddTriggerEffect("Player Kill All God Powers");
         rmSetTriggerEffectParamInt("Player",i);

         rmAddTriggerEffect("Message");
         rmSetTriggerEffectParam("Text","Zeus likes fairplay - so he grants Lightning Storm instead of Bolt.");

         rmAddTriggerEffect("Grant God Power");
         rmSetTriggerEffectParamInt("PlayerID",i);
         rmSetTriggerEffectParam("PowerName","Lightning Storm");
         rmSetTriggerEffectParamInt("Count",1);
      }
   }
}

void akCreatePlayerHome(int aPlayer=0, string aStart="", string aHero="")
{

    float lPosX = rmPlayerLocXFraction(aPlayer);
    float lPosZ = rmPlayerLocZFraction(aPlayer);
 
    int   lUnitPlaced = 0;
    int   lStartArmy = rmCreateArmy(aPlayer,"Start"+aPlayer);


    int startingSettlementID=rmCreateObjectDef("Starting settlement"+aPlayer);
    rmAddObjectDefItem(startingSettlementID, aStart, 1, 0.0);
    rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
    rmAddObjectDefToClass(startingSettlementID, rmClassID("player"));
    rmSetObjectDefMinDistance(startingSettlementID, 0.0);
    rmSetObjectDefMaxDistance(startingSettlementID, 0.0);
    if (lPosX <= 0.5)
      lPosX = lPosX + 0.03;
    else if (lPosX > 0.5)
      lPosX = lPosX - 0.03;
    if (lPosZ <= 0.5)
      lPosZ = lPosZ + 0.03;
    else if (lPosZ > 0.5)
      lPosZ = lPosZ - 0.03;
    rmPlaceObjectDefAtLoc(startingSettlementID, aPlayer, lPosX, lPosZ, 1);
    lUnitPlaced = rmGetUnitPlaced(startingSettlementID,0);


    int heroID=rmCreateObjectDef("Hero"+aPlayer);
    rmAddObjectDefItem(heroID, aHero, 1, 0.0);
    rmAddObjectDefToClass(heroID, rmClassID("starting settlement"));
    rmAddObjectDefToClass(heroID, rmClassID("player"));
    rmSetObjectDefMinDistance(heroID, 0.0);
    rmSetObjectDefMaxDistance(heroID, 0.0);

    if (lPosX <= 0.5)
      lPosX = lPosX + 0.04;
    else if (lPosX > 0.5)
      lPosX = lPosX - 0.04;
    if (lPosZ <= 0.5)
      lPosZ = lPosZ + 0.04;
    else if (lPosZ > 0.5)
      lPosZ = lPosZ - 0.04;
    rmPlaceObjectDefAtLoc(heroID, aPlayer, lPosX, lPosZ, 1);
}

void akCreateConvertTrigger(string aType="", int aArmy=-1, int aUnit=-1, int aUnitPlaced=-1)
{

    if (aArmy == -1)
      return;

    if (aUnit == -1)
      return;

    if (aUnitPlaced == -1)
      return;


    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmCreateTrigger("C"+aType+"A"+aArmy+"U"+aUnit+"P"+i);
      rmCreateTrigger("O20"+aType+"A"+aArmy+"U"+aUnit+"P"+i);
    }

    rmCreateTrigger("D"+aType+"A"+aArmy+"U"+aUnit);
    rmAddTriggerCondition("Is Dead");
    rmSetTriggerConditionParam("SrcObject",""+aUnitPlaced);

    rmAddTriggerEffect("Army Destroy");
    rmSetTriggerEffectParamArmy("SrcArmy",0,aArmy);

    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmAddTriggerEffect("Disable Trigger");
      rmSetTriggerEffectParam("TrigName","C"+aType+"A"+aArmy+"U"+aUnit+"P"+i);
      rmSetTriggerEffectParam("TrigName","O20"+aType+"A"+aArmy+"U"+aUnit+"P"+i);
      rmSetTriggerEffectParam("TrigName","FireC"+aType+"A"+aArmy+"U"+aUnit);
    }

    rmSetTriggerPriority(8);
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(false);
    rmSetTriggerLoop(false);



    for(i=1; <= cNumberNonGaiaPlayers)
    {

      rmSwitchToTrigger(rmTriggerID("C"+aType+"A"+aArmy+"U"+aUnit+"P"+i));

      for(j=1; <= cNumberNonGaiaPlayers)
      {
         if (i != j)
         {
           rmAddTriggerCondition("Units in Area");
           rmSetTriggerConditionParamInt("Player", j);
           rmSetTriggerConditionParam("DstObject",""+aUnitPlaced);
           rmSetTriggerConditionParam("UnitType",akGetHeroUnit(j));
           rmSetTriggerConditionParamFloat("Dist",10);
           rmSetTriggerConditionParam("Op","==");
           rmSetTriggerConditionParamInt("Count", 0);

           rmAddTriggerEffect("Disable Trigger");
           rmSetTriggerEffectParam("TrigName","C"+aType+"A"+aArmy+"U"+aUnit+"P"+j);
         }
         else
	 {
           rmAddTriggerCondition("Units in Area");
           rmSetTriggerConditionParamInt("Player", j);
           rmSetTriggerConditionParam("DstObject",""+aUnitPlaced);
           rmSetTriggerConditionParam("UnitType",akGetHeroUnit(i));
           rmSetTriggerConditionParamFloat("Dist",15);
           rmSetTriggerConditionParam("Op",">=");
           rmSetTriggerConditionParamInt("Count", 1);
	 }
      }

      rmAddTriggerEffect("Army Convert");
      rmSetTriggerEffectParamArmy("SrcArmy",0,aArmy);
      rmSetTriggerEffectParamInt("PlayerID", i);

      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID", rmTriggerID("O20"+aType+"A"+aArmy+"U"+aUnit+"P"+i));

      rmSetTriggerPriority(8);
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
    }

    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmSwitchToTrigger(rmTriggerID("O20"+aType+"A"+aArmy+"U"+aUnit+"P"+i));
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",20);

      rmAddTriggerCondition("Army Owned");
      rmSetTriggerConditionParamInt("Player",i);
      rmSetTriggerConditionParamArmy("SrcArmy",0,aArmy);


      if (aType == "Water")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",30);
      }
      else if (aType == "Farm")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",30);

      }
      else if (aType == "Cult")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","favor");
         rmSetTriggerEffectParamInt("Amount",10);
      }
      else if (aType == "Mark")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",10);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","wood");
         rmSetTriggerEffectParamInt("Amount",10);
      }
      else if (aType == "Ind")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",20);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","wood");
         rmSetTriggerEffectParamInt("Amount",20);
      }
      else if (aType == "Mil")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",-5);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",-5);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","wood");
         rmSetTriggerEffectParamInt("Amount",-5);
      }
      else if (aType == "LHous")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",-10);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",-5);
      }
      else if (aType == "SHous")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",-5);
      }
      else if (aType == "Beau")
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",10);
      }

      rmSetTriggerPriority(8);
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(true);
    }

    rmCreateTrigger("FireC"+aType+"A"+aArmy+"U"+aUnit);
    rmAddTriggerCondition("Timer");
    if (aType == "Water")
    {
	rmSetTriggerConditionParamInt("Param1",30);
    }
    else if (aType == "Farm")
    {
	rmSetTriggerConditionParamInt("Param1",10);
    }
    else if (aType == "Cult")
    {
	rmSetTriggerConditionParamInt("Param1",30);
    }
    else if (aType == "Mark")
    {
	rmSetTriggerConditionParamInt("Param1",20);
    }
    else if (aType == "Ind")
    {
	rmSetTriggerConditionParamInt("Param1",20);
    }
    else if (aType == "Mil")
    {
	rmSetTriggerConditionParamInt("Param1",30);
    }
    else if (aType == "LHous")
    {
	rmSetTriggerConditionParamInt("Param1",10);
    }
    else if (aType == "SHous")
    {
	rmSetTriggerConditionParamInt("Param1",10);
    }
    else if (aType == "Beau")
    {
	rmSetTriggerConditionParamInt("Param1",30);
    }

    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID", rmTriggerID("C"+aType+"A"+aArmy+"U"+aUnit+"P"+i));

      rmSetTriggerPriority(3);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(true);
    }
}


// Main entry point for random map script
void main(void)
{
   // Text
   rmSetStatusText("",0.01);

   // Set size.
   int playerTiles=3000;
   if(cMapSize == 1)
   {
      playerTiles = 4000;
      rmEchoInfo("Large map");
   }
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);


// ----------Randomize terrain
// Declare vars for terrain and objects

   int randomSet = 1;
   string mapTerrainType = "";
   string playerTerrainType = "";
   string industryTerrainType = "";
   string housingTerrainType = "";
   string farmingTerrainType = "";
   string militaryTerrainType = "";
   string marketTerrainType = "";
   string roadTerrainType = "";
   string beautyTerrainType = "";
   string decoTerrainType = "";
   string smallLakeWaterType = "";
   string middleLakeWaterType = "";
   string cliffType = "";
   string forestType = "";
   string treeType = "";
   string specialTreeType = "";
   string mapLightType = "";
   string startBuildingType = "";
   string foodAnimalType = "";
   string waterDeco1Type = "";
   string cultureObject1Type = "";
   string cultureObject2Type = "";
   string cultureObject3Type = "";
   string cultureObject4Type = "";
   string cultureObject5Type = "";
   string cultureObject6Type = "";
   string cultureObject7Type = "";
   string fishType = "";
   string bandit1Type = "";
   string bandit2Type = "";
   string bandit3Type = "";


   startBuildingType = "Settlement Level 1";

   randomSet = rmRandInt(1,3);
   switch (randomSet)
   {
     case 1:
	{
	   mapLightType = "Fimbulwinter";
	   mapTerrainType = "GreekRoadA";
	   roadTerrainType = "GreekRoadA";
	   playerTerrainType = "CityTileA";
	   industryTerrainType = "GrassDirt25";
	   militaryTerrainType = "GrassDirt25";
	   marketTerrainType = "GrassDirt25";
	   housingTerrainType = "CityTileA";
	   farmingTerrainType = "GrassDirt25";
	   beautyTerrainType = "GrassA";
	   decoTerrainType = "GrassB";
	   smallLakeWaterType = "Greek River";
	   middleLakeWaterType = "Greek River";
	   cliffType = "Greek";
	   forestType = "Mixed Oak Forest";
	   treeType = "Oak Tree";
	   specialTreeType = "Savannah Tree";
   	   bandit1Type = "Wolf";
	   bandit2Type = "Bear";
	   foodAnimalType = "Pig";
	   fishType = "Fish - Perch";
	   waterDeco1Type = "Water Lilly";
	   cultureObject1Type = "Temple";
	   cultureObject2Type = "Shrine";
	   cultureObject3Type = "Statue of Major God";
	   cultureObject4Type = "Statue of Major God";
	   cultureObject5Type = "Mist";
	   cultureObject6Type = "Columns";
	   cultureObject7Type = "Fountain";
	   break;
	}
     case 2:
	{
	   mapLightType = "Ghost Lake";
	   mapTerrainType = "EgyptianRoadA";
	   playerTerrainType = "CityTileA";
	   industryTerrainType = "SandDirt50";
	   militaryTerrainType = "SandDirt50";
	   marketTerrainType = "SandDirt50";
	   beautyTerrainType = "SandA";
	   housingTerrainType = "SandDirt50";
	   farmingTerrainType = "SandB";
	   roadTerrainType = "EgyptianRoadA";
	   decoTerrainType = "SandB";
	   smallLakeWaterType = "Savannah Water Hole";
	   middleLakeWaterType = "Savannah Water Hole";
	   cliffType = "Egyptian";
	   forestType = "Savannah Forest";
	   treeType = "Savannah Tree";
	   specialTreeType = "Palm";
   	   bandit1Type = "Hyena";
	   bandit2Type = "Lion";
	   foodAnimalType = "Chicken";
	   fishType = "Fish - Mahi";
	   waterDeco1Type = "Papyrus";
	   cultureObject1Type = "Temple";
	   cultureObject2Type = "Statue Pharaoh";
	   cultureObject3Type = "Statue Lion Left";
	   cultureObject4Type = "Statue Lion Right";
	   cultureObject5Type = "Mist";
	   cultureObject6Type = "Tent";
	   cultureObject7Type = "Fountain";
	   break;
	}
     case 3:
	{
	   mapLightType = "Dawn";
	   mapTerrainType = "NorseRoadA";
	   playerTerrainType = "SnowGrass75";
	   industryTerrainType = "SnowGrass50";
	   militaryTerrainType = "SnowGrass50";
	   marketTerrainType = "SnowGrass50";
	   housingTerrainType = "SnowGrass50";
	   beautyTerrainType = "SnowGrass75";
	   farmingTerrainType = "SnowGrass50";
	   roadTerrainType = "NorseRoadA";
	   decoTerrainType = "SnowGrass50";
	   smallLakeWaterType = "Norse River";
	   middleLakeWaterType = "Norse River";
	   cliffType = "Norse";
	   forestType = "Snow Pine Forest";
	   treeType = "Pine Snow";
	   specialTreeType = "Oak Tree";
   	   bandit1Type = "Wolf";
	   bandit2Type = "Fenris Wolf";
	   foodAnimalType = "Cow";
	   fishType = "Fish - Salmon";
	   waterDeco1Type = "Water Reeds";
	   cultureObject1Type = "Temple";
	   cultureObject2Type = "Longhouse";
	   cultureObject3Type = "Campfire";
	   cultureObject4Type = "Runestone";
	   cultureObject5Type = "Mist";
	   cultureObject6Type = "Rotting Log";
	   cultureObject7Type = "Rock Granite Small";
	   break;
	}
   }

   // Set up default water.
   rmSetSeaLevel(0.0);

   // Init map.
   rmSetSeaType(middleLakeWaterType);
   rmTerrainInitialize(mapTerrainType);
   rmSetLightingSet(mapLightType);
   rmSetGaiaCiv(cCivZeus);
   rmSetVCFile("akStreetFightVC");

   // Define some classes.
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classHill");
   int startSettle = rmDefineClass("starting settlement");
   int classCliff=rmDefineClass("cliff");
   int classArea=rmDefineClass("Area");
   int classWater=rmDefineClass("Water");
   int classIndustry=rmDefineClass("Industry");
   int classHousing=rmDefineClass("Housing");
   int classBeauty=rmDefineClass("Beauty");
   int classFarming=rmDefineClass("Farming");
   int classCulture=rmDefineClass("Culture");
   int classMilitary=rmDefineClass("Military");
   int classMarket=rmDefineClass("Market");
   int classForest=rmDefineClass("forest");
   int classSpecial=rmDefineClass("special");
   int classRoad=rmDefineClass("road");
   int classDistrict=rmDefineClass("District");


    // -------------Define constraints

   // Create a edge of map constraint.
   int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4));

   // Player area constraint.
   int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a little", classPlayer, 5);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20);


   // my special constraints
   int nearCliffConstraint=rmCreateClassDistanceConstraint("near cliffs", rmClassID("cliff"), 3.0);
   int spreadCliffConstraint=rmCreateClassDistanceConstraint("spread cliffs", rmClassID("cliff"), 8.0);
   int shortAvoidBuildings=rmCreateTypeDistanceConstraint("short avoid buildings", "Building", 2.0);

   int nearAreaConstraint=rmCreateClassDistanceConstraint("avoid near areas", classArea, 3.0);
   int medAreaConstraint=rmCreateClassDistanceConstraint("avoid med areas", classArea, 10.0);
   int farAreaConstraint=rmCreateClassDistanceConstraint("avoid far areas", classArea, 30.0);

   int nearIndustryConstraint=rmCreateClassDistanceConstraint("avoid near Industrys", classIndustry, 4.0);
   int medIndustryConstraint=rmCreateClassDistanceConstraint("avoid med Industrys", classIndustry, 12.0);
   int farIndustryConstraint=rmCreateClassDistanceConstraint("avoid far Industrys", classIndustry, 40.0);

   int nearFarmingConstraint=rmCreateClassDistanceConstraint("avoid near farmings", classFarming, 4.0);
   int medFarmingConstraint=rmCreateClassDistanceConstraint("avoid med farmings", classFarming, 12.0);
   int farFarmingConstraint=rmCreateClassDistanceConstraint("avoid far farmings", classFarming, 40.0);

   int nearCultureConstraint=rmCreateClassDistanceConstraint("avoid near Cultures", classCulture, 4.0);
   int medCultureConstraint=rmCreateClassDistanceConstraint("avoid med Cultures", classCulture, 12.0);
   int farCultureConstraint=rmCreateClassDistanceConstraint("avoid far Cultures", classCulture, 40.0);

   int nearMilitaryConstraint=rmCreateClassDistanceConstraint("avoid near Military", classMilitary, 4.0);
   int medMilitaryConstraint=rmCreateClassDistanceConstraint("avoid med Military", classMilitary, 12.0);
   int farMilitaryConstraint=rmCreateClassDistanceConstraint("avoid far Military", classMilitary, 40.0);

   int nearMarketConstraint=rmCreateClassDistanceConstraint("avoid near Market", classMarket, 4.0);
   int medMarketConstraint=rmCreateClassDistanceConstraint("avoid med Market", classMarket, 12.0);
   int farMarketConstraint=rmCreateClassDistanceConstraint("avoid far Market", classMarket, 40.0);

   int nearHousingConstraint=rmCreateClassDistanceConstraint("avoid near Housing", classHousing, 4.0);
   int medHousingConstraint=rmCreateClassDistanceConstraint("avoid med Housing", classHousing, 12.0);
   int farHousingConstraint=rmCreateClassDistanceConstraint("avoid far Housing", classHousing, 40.0);

   int nearBeautyConstraint=rmCreateClassDistanceConstraint("avoid near Beauty", classBeauty, 4.0);
   int medBeautyConstraint=rmCreateClassDistanceConstraint("avoid med Beauty", classBeauty, 12.0);
   int farBeautyConstraint=rmCreateClassDistanceConstraint("avoid far Beauty", classBeauty, 40.0);

   int nearWaterConstraint=rmCreateClassDistanceConstraint("avoid near Water", classWater, 4.0);
   int medWaterConstraint=rmCreateClassDistanceConstraint("avoid med Water", classWater, 12.0);
   int farWaterConstraint=rmCreateClassDistanceConstraint("avoid far Water", classWater, 30.0);

   int avoidSpecialConstraint=rmCreateClassDistanceConstraint("avoid special", classSpecial, 8.0);
   int avoidRoadConstraint=rmCreateClassDistanceConstraint("avoid road", classRoad, 3.0);


   // Forest constraint.
   int shortForestConstraint=rmCreateClassDistanceConstraint("avoid Forest", classForest, 2);
   int medForestConstraint=rmCreateClassDistanceConstraint("avoid Forest more ", classForest, 10);

   // Settlement constraint.
   int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 5.0);
   int farAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by long distance", "AbstractSettlement", 50.0);
   int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);

   // Tower constraint.
   int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 20.0);
   int avoidTower2=rmCreateTypeDistanceConstraint("objects avoid towers", "tower", 22.0);

   // District Constraint.
   int shortAvoidDistrict=rmCreateClassDistanceConstraint("short avoid revealer", classDistrict, 5.0);
   int avoidDistrict=rmCreateClassDistanceConstraint("avoid revealer", classDistrict, 12.0);

   // Gold
   int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
   int shortAvoidGold=rmCreateTypeDistanceConstraint("gold vs. gold", "gold", 24.0);

   // Herd animals
   int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 20.0);
   int avoidFood=rmCreateTypeDistanceConstraint("avoid food", "food", 12.0);
   int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);

   // Avoid impassable land
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 8.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "land", false, 5.0);
   int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 20.0);
   int cliffConstraint=rmCreateClassDistanceConstraint("cliff v cliff", rmClassID("cliff"), 30.0);
   int shortCliffConstraint=rmCreateClassDistanceConstraint("stuff v cliff", rmClassID("cliff"), 10.0);


   // -------------Define objects
   // Close Objects


   // ---Basic Triggers
   akCreateBasicTriggers();
   akCreateTechTriggers();
   akCreateWinLoseTriggers();

   // Set up player areas.
   float playerFraction=rmAreaTilesToFraction(4000);
   int randI=rmRandInt(1,cNumberNonGaiaPlayers);
   for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);

      // Set the location.
      if ((randI+i)%cNumberNonGaiaPlayers == 0)
        rmPlacePlayer(i, 0.03, 0.97);
      else if ((randI+i)%cNumberNonGaiaPlayers == 1)
        rmPlacePlayer(i, 0.97, 0.03);
      else if ((randI+i)%cNumberNonGaiaPlayers == 2)
        rmPlacePlayer(i, 0.97, 0.97);
      else if ((randI+i)%cNumberNonGaiaPlayers == 3)
        rmPlacePlayer(i, 0.03, 0.03);
      else if ((randI+i)%cNumberNonGaiaPlayers == 4)
        rmPlacePlayer(i, 0.03, 0.5);
      else if ((randI+i)%cNumberNonGaiaPlayers == 5)
        rmPlacePlayer(i, 0.97, 0.5);
      else if ((randI+i)%cNumberNonGaiaPlayers == 6)
        rmPlacePlayer(i, 0.5, 0.03);
      else if ((randI+i)%cNumberNonGaiaPlayers == 8)
        rmPlacePlayer(i, 0.5, 0.97);

      // Assign to the player.
      rmSetAreaLocPlayer (id, i);
      rmSetPlayerArea(i, id);

      // Set the size.
      rmSetAreaSize(id, 0.05*playerFraction, 0.07*playerFraction);

      rmAddAreaToClass(id, classPlayer);
//      rmSetAreaWarnFailure(id, false);

      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 2);
      rmSetAreaMinBlobDistance(id, 2.0);
      rmSetAreaMaxBlobDistance(id, 30.0);
      rmSetAreaCoherence(id, 0.7);

      rmSetAreaBaseHeight(id, 4.0);
      rmSetAreaSmoothDistance(id, 20);

      // Set type.
      rmSetAreaTerrainType(id, playerTerrainType);
//      rmAddAreaTerrainLayer(id, decoTerrainType, 0, 8);

      rmAddAreaToClass(id, classArea);
   }

   // Build the areas.
   rmBuildAllAreas();

   // Place starting settlements.

   for(i=1; <cNumberPlayers)
   {
	akCreatePlayerHome (i, startBuildingType, akGetHeroUnit(i));
   }



   // Slight Elevation
   int numTries=6*cNumberPlayers;
   for(i=1; <numTries)
   {
      int elevID=rmCreateArea("playerwrinkle"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(25));
//      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmSetAreaBaseHeight(elevID, rmRandFloat(1.2, 3.5));
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmAddAreaConstraint(elevID, farStartingSettleConstraint);
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 3);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 20.0);
      rmSetAreaCoherence(elevID, 0.0);
      rmBuildArea(elevID);
   }


/*
   // Settlements.
   id=rmAddFairLoc("Settlement", false, true,  20, 70, 20, 10);

   id=rmAddFairLoc("Settlement", true, false, 20, 70, 20, 10);

   if(rmPlaceFairLocs())
   {
      id=rmCreateObjectDef("far settlement2");
      rmAddObjectDefItem(id, "Settlement", 1, 0.0);
      for(i=1; <cNumberPlayers)
      {
         for(j=0; <rmGetNumberFairLocs(i))
            rmPlaceObjectDefAtLoc(id, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
      }
   }
*/
   rmSetStatusText("",0.20);

   // Towers.
   // towers avoid other towers
/*
   int startingTowerID=rmCreateObjectDef("Starting tower");
   rmAddObjectDefItem(startingTowerID, "tower", 3, 1.0);
   rmSetObjectDefMinDistance(startingTowerID, 22.0);
   rmSetObjectDefMaxDistance(startingTowerID, 28.0);
   rmAddObjectDefConstraint(startingTowerID, avoidTower);
   rmAddObjectDefConstraint(startingTowerID, avoidImpassableLand);

   rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);
*/

   // Slight Elevation
   numTries=30*cNumberNonGaiaPlayers;
   int failCount=0;
   for(i=0; <numTries)
   {
      elevID=rmCreateArea("wrinkle"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(120));
      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmSetAreaBaseHeight(elevID, rmRandFloat(2.0, 4.0));
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 3);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 20.0);
      rmSetAreaCoherence(elevID, 0.0);

      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==3)
            break;
      }
      else
         failCount=0;
   }


   // Elev.
   numTries=10*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      elevID=rmCreateArea("elev"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(120));
      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmSetAreaBaseHeight(elevID, rmRandFloat(3.0, 4.0));
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 5);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 40.0);
      rmSetAreaCoherence(elevID, 0.0);

      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==3)
            break;
      }
      else
         failCount=0;
   }


   for(i=0; <1*(cNumberNonGaiaPlayers))
   {

      // Water
      int id2=rmCreateArea("Water"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(450), rmAreaTilesToFraction(500));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaWaterType(id2, smallLakeWaterType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 1.0);
      rmSetAreaMaxBlobDistance(id2, 30.0);
      rmSetAreaCoherence(id2, 0.8);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, medAreaConstraint);
      rmAddAreaConstraint(id2, farWaterConstraint);
      rmAddAreaConstraint(id2, farStartingSettleConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, playerConstraint);

      rmBuildArea(id2); 
/*
      int tempRevealerID=rmCreateObjectDef("WaterRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/ 
      int waterObjectID=rmCreateObjectDef("WaterObject1_"+i);
      rmAddObjectDefItem(waterObjectID, "Dock", 1, 3.0);
      rmSetObjectDefMinDistance(waterObjectID, 0.0);
      rmSetObjectDefMaxDistance(waterObjectID, 20.0);
      rmAddObjectDefConstraint(waterObjectID, shortAvoidDistrict);
      rmPlaceObjectDefInArea(waterObjectID, 0, id2, 1);
      rmAddObjectDefToClass(waterObjectID, classDistrict);
      tempArmy = rmCreateArmy(0,"ArmyWater"+waterObjectID);
      rmAddUnitsToArmy(0,tempArmy,waterObjectID);
      tempUnit = waterObjectID;
      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("Water", tempArmy, tempUnit, tempUnitPlaced);

      int waterObject2ID=rmCreateObjectDef("WaterObject2_"+i);
      rmAddObjectDefItem(waterObject2ID, waterDeco1Type, 11, 9.0);
      rmSetObjectDefMinDistance(waterObject2ID, 0.0);
      rmSetObjectDefMaxDistance(waterObject2ID, 30.0);
      rmPlaceObjectDefInArea(waterObject2ID, 0, id2, 1);

      int waterObject3ID=rmCreateObjectDef("WaterObject3_"+i);
      rmAddObjectDefItem(waterObject3ID, "Water decoration", 25, 30.0);
      rmSetObjectDefMinDistance(waterObject3ID, 0.0);
      rmSetObjectDefMaxDistance(waterObject3ID, 40.0);
      rmPlaceObjectDefInArea(waterObject3ID, 0, id2, 1);


      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classWater);
   }

   for(i=0; <2*(cNumberNonGaiaPlayers))
   {

      // Industry 
      id2=rmCreateArea("Industry"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(70), rmAreaTilesToFraction(80));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, industryTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, medAreaConstraint);
      rmAddAreaConstraint(id2, farWaterConstraint);
      rmAddAreaConstraint(id2, farIndustryConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, shortPlayerConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);

      rmBuildArea(id2); 

      tempArmy = rmCreateArmy(0,"ArmyIndustry"+i);
      tempUnit = -1;
      tempUnitPlaced = -1;

/*
      tempRevealerID=rmCreateObjectDef("IndustryRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/

      int industryID=rmCreateObjectDef("Industry"+i);
      rmSetObjectDefMinDistance(industryID, 0.0);
      rmSetObjectDefMaxDistance(industryID, 5.0);
      rmAddObjectDefConstraint(industryID, shortAvoidDistrict);
      rmAddObjectDefItem(industryID, "Armory", 1, 0.0);
      rmAddObjectDefItem(industryID, "Dwarf Foundry", 1, 10.0);
      rmAddObjectDefItem(industryID, "Mining Camp", 1, 8.0);
      rmAddObjectDefItem(industryID, "Lumber Camp", 1, 8.0);
      rmAddObjectDefItem(industryID, "Barrel", 3, 6.0);
      rmAddObjectDefItem(industryID, "Crate", 2, 6.0);
      rmPlaceObjectDefInArea(industryID, 0, id2, 1);
      rmAddObjectDefToClass(industryID, classDistrict);
      rmAddUnitsToArmy(0,tempArmy,industryID);
      tempUnit = industryID;

      int towerID=rmCreateObjectDef("Towers"+i);
      rmAddObjectDefConstraint(towerID, avoidTower);
      rmAddObjectDefConstraint(towerID, nearAreaConstraint);
      rmAddObjectDefToClass(towerID, classDistrict);
      rmAddObjectDefItem(towerID, "tower", 4, 1.0);
      rmSetObjectDefMinDistance(towerID, 10.0);
      rmSetObjectDefMaxDistance(towerID, 20.0);
      rmPlaceObjectDefInArea(towerID, 0, id2, 4);
      rmAddUnitsToArmy(0,tempArmy,towerID);


      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("Ind", tempArmy,tempUnit,tempUnitPlaced);

      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classIndustry);
   }

   rmSetStatusText("",0.40);

   for(i=0; <2*(cNumberNonGaiaPlayers))
   {

      // Culture
      id2=rmCreateArea("Culture"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(80), rmAreaTilesToFraction(100));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, playerTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, farCultureConstraint);
      rmAddAreaConstraint(id2, farIndustryConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, medAreaConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);
      rmAddAreaConstraint(id2, shortPlayerConstraint);

      rmBuildArea(id2); 
      tempArmy = rmCreateArmy(0,"ArmyCulture"+i);
      tempUnit = -1;
      tempUnitPlaced = -1;
/*
      tempRevealerID=rmCreateObjectDef("CultureRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/
      int cultureID=rmCreateObjectDef("CulturePlace"+i);
      rmSetObjectDefMinDistance(cultureID, 0.0);
      rmSetObjectDefMaxDistance(cultureID, 0.0);
      rmAddObjectDefConstraint(cultureID, shortAvoidDistrict);
      rmAddObjectDefItem(cultureID, cultureObject1Type, 1, 0.0);
      rmAddObjectDefItem(cultureID, cultureObject2Type, 1, 12.0);
      rmAddObjectDefItem(cultureID, cultureObject3Type, 1, 12.0);
      rmAddObjectDefItem(cultureID, cultureObject4Type, 1, 12.0);
      rmAddObjectDefItem(cultureID, cultureObject5Type, 2, 10.0);
      rmAddObjectDefItem(cultureID, cultureObject6Type, 2, 10.0);
      rmAddObjectDefItem(cultureID, cultureObject7Type, 4, 10.0);
      rmAddObjectDefItem(cultureID, "Relic", 1, 10.0);
      rmPlaceObjectDefInArea(cultureID, 0, id2, 1);
      rmAddObjectDefToClass(cultureID, classDistrict);

      rmAddUnitsToArmy(0,tempArmy,cultureID);
      tempUnit = cultureID;

      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("Cult", tempArmy,tempUnit,tempUnitPlaced);

      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classCulture);
   }

   for(i=0; <2*(cNumberNonGaiaPlayers))
   {

      // Military
      id2=rmCreateArea("Military"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(90), rmAreaTilesToFraction(100));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, militaryTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, farCultureConstraint);
      rmAddAreaConstraint(id2, farFarmingConstraint);
      rmAddAreaConstraint(id2, farWaterConstraint);
      rmAddAreaConstraint(id2, farMilitaryConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, medAreaConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);
      rmAddAreaConstraint(id2, shortPlayerConstraint);


      rmBuildArea(id2); 
      tempArmy = rmCreateArmy(0,"ArmyMilitary"+i);
      tempUnit = -1;
      tempUnitPlaced = -1;
/*
      tempRevealerID=rmCreateObjectDef("MiltaryRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/

      int militaryID=rmCreateObjectDef("Military"+i);
      rmSetObjectDefMinDistance(militaryID, 0.0);
      rmSetObjectDefMaxDistance(militaryID, 5.0);
      rmAddObjectDefConstraint(militaryID, shortAvoidDistrict);
      rmAddObjectDefItem(militaryID, "Barracks", 1, 0.0);
      rmAddObjectDefItem(militaryID, "Academy", 1, 10.0);
      rmAddObjectDefItem(militaryID, "Archery Range", 1, 10.0);
      rmAddObjectDefItem(militaryID, "Stable", 1, 10.0);
      rmAddObjectDefItem(militaryID, "Siege Camp", 1, 10.0);
      rmAddObjectDefItem(militaryID, "Broken Siege Weapons", 2, 6.0);
      rmPlaceObjectDefInArea(militaryID, 0, id2, 1);
      rmAddObjectDefToClass(militaryID, classDistrict);

      rmAddUnitsToArmy(0,tempArmy,militaryID);
      tempUnit = militaryID;

      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("Mil", tempArmy,tempUnit,tempUnitPlaced);

      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classMilitary);

   }


   for(i=0; <2*(cNumberNonGaiaPlayers))
   {

      // Farmings
      id2=rmCreateArea("Farmings"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(70));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, farmingTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, farFarmingConstraint);
      rmAddAreaConstraint(id2, medIndustryConstraint);
      rmAddAreaConstraint(id2, medAreaConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);
      rmAddAreaConstraint(id2, shortPlayerConstraint);

      rmBuildArea(id2); 

      tempArmy = rmCreateArmy(0,"ArmyFarming"+i);
      tempUnit = -1;

/*
      tempRevealerID=rmCreateObjectDef("FarmRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/
      int farmID=rmCreateObjectDef("Farming1_"+i);
      rmAddObjectDefItem(farmID, "Granary", 1, 0.0);
      rmAddObjectDefItem(farmID, "Farm", 8, 6.0);
      rmAddObjectDefItem(farmID, foodAnimalType, 2, 10.0);
      rmAddObjectDefItem(farmID, "Fence Stone", 1, 8.0);
      rmSetObjectDefMinDistance(farmID, 0.0);
      rmSetObjectDefMaxDistance(farmID, 2.0);
      rmAddObjectDefConstraint(farmID, shortAvoidDistrict);
      rmPlaceObjectDefInArea(farmID, 0, id2, 1);
      rmAddObjectDefToClass(farmID, classDistrict);

      rmAddUnitsToArmy(0,tempArmy,farmID);
      tempUnit = farmID;

      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("Farm", tempArmy,tempUnit,tempUnitPlaced);

      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classFarming);
   }


   for(i=0; <2*(cNumberNonGaiaPlayers))
   {

      // Market
      id2=rmCreateArea("Market"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(80), rmAreaTilesToFraction(100));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, marketTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, medIndustryConstraint);
      rmAddAreaConstraint(id2, medMilitaryConstraint);
      rmAddAreaConstraint(id2, farMarketConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, medAreaConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);
      rmAddAreaConstraint(id2, shortPlayerConstraint);

      rmBuildArea(id2); 

      tempArmy = rmCreateArmy(0,"ArmyMarket"+i);
      tempUnit = -1;
/*
      tempRevealerID=rmCreateObjectDef("MarketRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/
      int marketID=rmCreateObjectDef("Market"+i);
      rmSetObjectDefMinDistance(marketID, 0.0);
      rmSetObjectDefMaxDistance(marketID, 2.0);
      rmAddObjectDefConstraint(marketID, shortAvoidDistrict);
      rmAddObjectDefItem(marketID, "Market", 1, 0.0);
      rmAddObjectDefItem(marketID, "Market Stall", 5, 6.0);
      rmAddObjectDefItem(marketID, "Crate Small", 2, 6.0);
      rmAddObjectDefItem(marketID, "Rugs", 2, 6.0);
      rmPlaceObjectDefInArea(marketID, 0, id2, 1);
      rmAddObjectDefToClass(marketID, classDistrict);

      tempUnit = marketID;
      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("Mark", tempArmy,tempUnit,tempUnitPlaced);

      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classMarket);
  }


   rmSetStatusText("",0.60);

   for(i=0; <2*(cNumberNonGaiaPlayers))
   {

      // large Housings 
      id2=rmCreateArea("LargeHousings"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(70), rmAreaTilesToFraction(80));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, housingTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, farIndustryConstraint);
      rmAddAreaConstraint(id2, farMilitaryConstraint);
      rmAddAreaConstraint(id2, farHousingConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, nearAreaConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);
      rmAddAreaConstraint(id2, shortPlayerConstraint);

      rmBuildArea(id2); 

      tempArmy = rmCreateArmy(0,"ArmyLHouse"+i);
      tempUnit = -1;

/*
      tempRevealerID=rmCreateObjectDef("LHouseRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmAddObjectDefConstraint(tempRevealerID, shortAvoidBuildings);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/

      int houseID=rmCreateObjectDef("LargeHousing"+i);
      rmAddObjectDefItem(houseID, "House", 8, 6.0);
      rmAddObjectDefItem(houseID, "Fountain", 3, 0.0);
      rmAddObjectDefItem(houseID, treeType, 3, 2.0);
      rmSetObjectDefMinDistance(houseID, 0.0);
      rmSetObjectDefMaxDistance(houseID, 2.0);
      rmAddObjectDefConstraint(houseID, shortAvoidDistrict);
      rmPlaceObjectDefInArea(houseID, 0, id2, 1);
      rmAddObjectDefToClass(houseID, classDistrict);

      tempUnit = houseID;
      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("LHous", tempArmy,tempUnit,tempUnitPlaced);

      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classHousing);
   }


   for(i=0; <3*(cNumberNonGaiaPlayers))
   {

      // small Housings 
      id2=rmCreateArea("SmallHousings"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(15), rmAreaTilesToFraction(25));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, housingTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, medIndustryConstraint);
      rmAddAreaConstraint(id2, medMilitaryConstraint);
      rmAddAreaConstraint(id2, nearAreaConstraint);
      rmAddAreaConstraint(id2, medHousingConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);
      rmAddAreaConstraint(id2, shortPlayerConstraint);

      rmBuildArea(id2); 

      tempArmy = rmCreateArmy(0,"ArmySHouse"+i);
      tempUnit = -1;

/*
      tempRevealerID=rmCreateObjectDef("SHouseRevealer"+i);
      rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
      rmAddObjectDefToClass(tempRevealerID, classRevealer);
      rmSetObjectDefMinDistance(tempRevealerID, 0.0);
      rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
      rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/

      houseID=rmCreateObjectDef("SmallHousing"+i);
      rmAddObjectDefItem(houseID, "House", 5, 5.0);
      rmAddObjectDefItem(houseID, treeType, 1, 0.0);
      rmAddObjectDefItem(houseID, "Fountain", 2, 3.0);
      rmSetObjectDefMinDistance(houseID, 0.0);
      rmSetObjectDefMaxDistance(houseID, 1.0);
      rmAddObjectDefConstraint(houseID, shortAvoidDistrict);
      rmPlaceObjectDefInArea(houseID, 0, id2, 1);
      rmAddObjectDefToClass(houseID, classDistrict);

      tempUnit = houseID;
      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger("SHous", tempArmy,tempUnit,tempUnitPlaced);

      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classHousing);
   }


   for(i=0; <2*(cNumberNonGaiaPlayers))
   {

      // Cliff
      id2=rmCreateArea("Cliff"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(150), rmAreaTilesToFraction(250));
      rmSetAreaWarnFailure(id2, false);

      rmSetAreaCliffType(id2, cliffType);
      rmSetAreaCliffEdge(id2, 2, 0.45, 0.2, 1.0, 1);
      rmSetAreaCliffPainting(id2, false, true, true, 1.5, true);
      rmSetAreaCliffHeight(id2, rmRandFloat(1.5,3.5), 1.0, 0.2);
      rmSetAreaSmoothDistance(id2, 20);


      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);

      rmAddAreaConstraint(id2, nearAreaConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortPlayerConstraint);
      rmAddAreaConstraint(id2, shortAvoidDistrict);

      rmBuildArea(id2); 
      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classCliff);

      int cliffID=rmCreateObjectDef("CliffObject"+i);
      rmAddObjectDefItem(cliffID, specialTreeType, 5, 3.0);
      rmSetObjectDefMinDistance(cliffID, 0.0);
      rmSetObjectDefMaxDistance(cliffID, 2.0);
      rmPlaceObjectDefInArea(cliffID, 0, id2, 1);

   }


   for(i=0; <6*(cNumberNonGaiaPlayers))
   {

      // Beauty
      id2=rmCreateArea("Beauty"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(70));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaTerrainType(id2, beautyTerrainType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 1);
      rmSetAreaMinBlobDistance(id2, 0.0);
      rmSetAreaMaxBlobDistance(id2, 0.0);
      rmSetAreaCoherence(id2, 1.0);
      rmSetAreaBaseHeight(id2, 2.0);

      rmAddAreaConstraint(id2, nearAreaConstraint);
      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortPlayerConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);

      rmBuildArea(id2); 

      int beautyID=rmCreateObjectDef("BeautyObject"+i);
      rmSetObjectDefMinDistance(beautyID, 0.0);
      rmSetObjectDefMaxDistance(beautyID, 2.0);
      rmAddObjectDefConstraint(beautyID, shortAvoidDistrict);
      if (i <= 2*(cNumberNonGaiaPlayers))
      {
        rmAddObjectDefItem(beautyID, "Gold Mine", 1, 0.0);
        rmAddObjectDefItem(beautyID, treeType, 5, 6.0);
        rmPlaceObjectDefInArea(beautyID, 0, id2, 1);
      }
      else if (i <= 4*(cNumberNonGaiaPlayers))
      {
        tempArmy = rmCreateArmy(0,"ArmyBeauty"+i);
        tempUnit = -1;
/*
        tempRevealerID=rmCreateObjectDef("BeautyRevealer"+i);
        rmAddObjectDefItem(tempRevealerID, "Flag", 1, 0.0);
        rmAddObjectDefToClass(tempRevealerID, classRevealer);
        rmSetObjectDefMinDistance(tempRevealerID, 0.0);
        rmSetObjectDefMaxDistance(tempRevealerID, 0.0);
        rmPlaceObjectDefInArea(tempRevealerID, 0, id2, 1);
*/
        rmAddObjectDefItem(beautyID, "Granary", 1, 0.0);
        rmAddObjectDefItem(beautyID, foodAnimalType, 3, 6.0);
        rmPlaceObjectDefInArea(beautyID, 0, id2, 1);
        rmAddObjectDefToClass(beautyID, classDistrict);
        rmAddUnitsToArmy(0,tempArmy,beautyID);

        tempUnit = beautyID;
        tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);

        rmAddUnitsToArmy(0,tempArmy,tempUnit);
        akCreateConvertTrigger("Beau", tempArmy,tempUnit,tempUnitPlaced);
      }
      else 
      {
        rmAddObjectDefItem(beautyID, cultureObject6Type, 3, 5.0);
        rmAddObjectDefItem(beautyID, cultureObject7Type, 5, 8.0);
        rmPlaceObjectDefInArea(beautyID, 0, id2, 1);
      }
      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classBeauty);
   }



   for(i=0; <4*(cNumberNonGaiaPlayers))
   {
      // Forest 
      id2=rmCreateArea("Forest Patch"+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(15), rmAreaTilesToFraction(20));
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaForestType(id2, forestType);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 50);
      rmSetAreaMinBlobDistance(id2, 5.0);
      rmSetAreaMaxBlobDistance(id2, 40.0);
      rmSetAreaCoherence(id2, 0.0);
      rmSetAreaBaseHeight(id2, 4.0);

      rmAddAreaConstraint(id2, shortAvoidBuildings);
      rmAddAreaConstraint(id2, shortAvoidSettlement);
      rmAddAreaConstraint(id2, nearAreaConstraint);
      rmAddAreaConstraint(id2, medForestConstraint);
      rmAddAreaConstraint(id2, shortAvoidDistrict);

      rmBuildArea(id2); 
      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classForest);
   } 


// Forest
    for(i=1; <3*cNumberPlayers)
   {

      int forest2ID=rmCreateArea("Forest_"+i);
      rmSetAreaWarnFailure(forest2ID, false);
      rmSetAreaSize(forest2ID, rmAreaTilesToFraction(5), rmAreaTilesToFraction(15));
      rmSetAreaForestType(forest2ID, forestType);
      rmSetAreaMinBlobs(forest2ID, 5);
      rmSetAreaMaxBlobs(forest2ID, 20);
      rmSetAreaMinBlobDistance(forest2ID, 2.0);
      rmSetAreaMaxBlobDistance(forest2ID, 20.0);
      rmSetAreaCoherence(forest2ID, 0.1);
      rmSetAreaBaseHeight(forest2ID, 3.5);

      rmSetAreaSmoothDistance(forest2ID, 50);
      rmAddAreaConstraint(forest2ID, shortPlayerConstraint);
      rmAddAreaConstraint(forest2ID, nearAreaConstraint);
      rmAddAreaConstraint(forest2ID, shortForestConstraint);
      rmAddAreaConstraint(forest2ID, shortAvoidDistrict);
      rmBuildArea(forest2ID);
      rmAddAreaToClass(forest2ID, classForest);
      rmAddAreaToClass(forest2ID, classArea);
     }




   // NearGold
   int goldVsGoldID=rmCreateTypeDistanceConstraint("gold vs gold", "Gold Mine", 20.0);

   int playerGoldID=rmCreateObjectDef("PlayerGold");
   rmAddObjectDefItem(playerGoldID, "Gold Mine", 1, 0.0);
   rmSetObjectDefMinDistance(playerGoldID, 10.0);
   rmSetObjectDefMaxDistance(playerGoldID, 30);
   rmAddObjectDefConstraint(playerGoldID, goldVsGoldID);
   rmAddObjectDefConstraint(playerGoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(playerGoldID, avoidSpecialConstraint);
   rmAddObjectDefConstraint(playerGoldID, shortAvoidBuildings);
   rmAddObjectDefConstraint(playerGoldID, shortPlayerConstraint);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 3);
//   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers); 


// fish
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 30);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);

   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, fishType, 3, 9.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);

   rmSetStatusText("",0.80);
}
