//*****************************
//* akStreetFightVC - VC script
//* Created by AK, ZeroDexter
//* 2003-1-2 to 2003-1-18
//*****************************

include "basicvcnomain.xs";

int statsIntervall=120;
float lastStatsTime=0;

int baseHousing=0;
int baseWater=0;
int baseArmory=0;
int baseTemple=0;
int baseBarracks=0;
int baseGranary=0;
int baseMarket=0;

int actHousing=0;
int actWater=0;
int actArmory=0;
int actTemple=0;
int actBarracks=0;
int actGranary=0;
int actMarket=0;

rule akStreetFightInitStats
   minInterval 5
   maxInterval 20
   active
{
  baseHousing=trPlayerUnitCountSpecific(0, "House");
  baseWater=trPlayerUnitCountSpecific(0, "Dock");
  baseArmory=trPlayerUnitCountSpecific(0, "Armory");
  baseTemple=trPlayerUnitCountSpecific(0, "Temple");
  baseBarracks=trPlayerUnitCountSpecific(0, "Barracks");
  baseGranary=trPlayerUnitCountSpecific(0, "Granary");
  baseMarket=trPlayerUnitCountSpecific(0, "Market");
  xsDisableSelf();
}


int akCalcStats (int i=0)
{
  actHousing=trPlayerUnitCountSpecific(i, "House");
  actWater=trPlayerUnitCountSpecific(i, "Dock");
  actArmory=trPlayerUnitCountSpecific(i, "Armory");
  actTemple=trPlayerUnitCountSpecific(i, "Temple");
  actBarracks=trPlayerUnitCountSpecific(i, "Barracks");
  actGranary=trPlayerUnitCountSpecific(i, "Granary");
  actMarket=trPlayerUnitCountSpecific(i, "Market");


  float statsCount=0;
  if (baseHousing > 0 && actHousing > 0)
    statsCount = statsCount+100*actHousing/baseHousing;
  if (baseWater > 0 && actWater > 0)
    statsCount = statsCount+100*actWater/baseWater;
  if (baseArmory > 0 && actArmory > 0)
    statsCount = statsCount+100*actArmory/baseArmory;
  if (baseTemple > 0 && actTemple > 0)
    statsCount = statsCount+100*actTemple/baseTemple;
  if (baseBarracks > 0 && actBarracks > 0)
    statsCount = statsCount+100*actBarracks/baseBarracks;
  if (baseGranary > 0 && actGranary > 0)
    statsCount = statsCount+100*actGranary/baseGranary;
  if (baseMarket > 0 && actMarket > 0)
    statsCount = statsCount+100*actMarket/baseMarket;
  return (statsCount);
}

rule akStreetFightStats
   minInterval 5
   maxInterval 20
   active
{
   // wait for the next time  
   if (trTimeMS() < lastStatsTime+statsIntervall*1000)
      return;
   lastStatsTime=trTimeMS(); 

   int prevPlayer = xsGetContextPlayer();
   int maxValue = 0;
   int secondValue = 0;
   int actValue = 0;
   int bestPlayer=0;
   int secondPlayer=0;
   int dispGameTime=lastStatsTime/1000/60;

   
   trChatSend(0, "In game statistics for akStreetFight at "+ dispGameTime +" minutes gameplay.");
   trChatSend(0, "MaxDom: 700 ("+baseHousing+" H, "+baseWater+" W, "+baseArmory+" A, "+baseTemple+" T, "+baseBarracks+" B, "+baseGranary+" G, "+baseMarket+" M). ");
   for (i=1; < cNumberPlayers)
   {
      if (trPlayerActive(i))
      {
        xsSetContextPlayer(i);

        actValue = akCalcStats(i);	
        if (actValue > maxValue)
        {
          maxValue=actValue;
          bestPlayer = i;
        }
        else if (actValue > secondValue)
        {
          secondValue=actValue;
          secondPlayer = i;
        }
        trChatSend(0, "Player"+i+"Dom: "+ actValue + " ("+actHousing+" H, "+actWater+" W, "+actArmory+" A, "+actTemple+" T, "+actBarracks+" B, "+actGranary+" G, "+actMarket+" M). ");
      }
      else 
        trChatSend(0, "Player "+i+" is gone.");     
   }
   xsSetContextPlayer(prevPlayer);
   if (maxValue > 0)
   {
     if (maxValue > secondValue + 650)
       trChatSend(0, "Player " + bestPlayer + " is the only one hero!");
     else if (maxValue > secondValue + 500)
       trChatSend(0, "Player " + bestPlayer + " rules!");
     else if (maxValue > secondValue + 200)
       trChatSend(0, "Player " + bestPlayer + " rocks!");
     else if (maxValue > secondValue + 100)
       trChatSend(0, "Player " + bestPlayer + " is dominating!");
     else if (maxValue > secondValue + 50)
       trChatSend(0, "Player " + bestPlayer + " is leading!");
     else if (maxValue > secondValue + 5)
       trChatSend(0, "Player " + bestPlayer + " is ahead!");
   }
}



